@echo off

:: ---------------------------------------------------------------------------------------------------------------
::	H:	Jahrhundert
::	J:	Jahreszahl innerhalb des Jahrhunderts
::	M:	Monat
::		Fr die Monate ist die altrmische Zeitrechnung zu verwenden, d.h. Mrz M = 1, April M = 2,......,
::		Dezember M = 10, Januar und Februar sind der 11. bzw. 12. Monat des Vorjahres.
::	T:	Tag
::	W:	Wochentag
::		(Sonntag = 0, Montag = 1, Dienstag = 2, Mittwoch = 3, Donnerstag = 4, Freitag = 5, Samstag = 6)
:: ---------------------------------------------------------------------------------------------------------------

echo  ____________________________________________________________________________
echo                                                      http://www.ProCompSys.de
echo.
echo  	version 1.0  2004-12-14 by Uwe Weitz @ ProCompSys
echo. 
echo    Wochentag zu frei definierbarem Datum ermitteln
echo    fr Windows 2000 ^& Windows XP
echo.
echo  ____________________________________________________________________________

echo.
pause

cls
echo.


:start

cls

echo.
echo.

set /p Datum=Bitte ein Datum (tt.mm.jjjj) eingeben: 

call :checkentry

set T=%Datum:~0,2%
set M=%Datum:~3,2%
set J=%Datum:~8,2%
set H=%Datum:~6,2%


:: --- fhrende Nullen entfernen ---
   if %T:~0,1%==0 set T=%T:~1,1%
   if %M:~0,1%==0 set M=%M:~1,1%
   if %J:~0,1%==0 set J=%J:~1,1%
:: ---------------------------------

if %M% LSS 3 (
   call :anpassen01
   ) else (
        call :anpassen02
        )

set /a W=(%T%+(26*%M%-2)/10+%J%+(%J%/4)+(%H%/4)-(2*%H%))%%7

set /a finalW=%W%%%7

if not %finalW% GEQ 0 (
   set /a finalW=7-%finalW:~1,1%
   )

if "%finalW%"=="0" (
 echo Das ist ein Sonntag.
 )
if "%finalW%"=="1" (
 echo Das ist ein Montag.
 )
if "%finalW%"=="2" (
 echo Das ist ein Dienstag. 
 )
if "%finalW%"=="3" (
 echo Das ist ein Mittwoch. 
 )
if "%finalW%"=="4" (
 echo Das ist ein Donnerstag. 
 )
if "%finalW%"=="5" (
 echo Das ist ein Freitag. 
 )
if "%finalW%"=="6" (
 echo Das ist ein Samstag. 
 )

goto ENDE


:: ===================================================================================
:: ===================================================================================
:: ===================================================================================


:checkentry
   if '%Datum:~9,1%'=='' goto :Meldung
   if not '%Datum:~2,1%'=='.' goto :Meldung
   if not '%Datum:~5,1%'=='.' goto :Meldung
   goto :EOF

:Meldung
   echo Bitte Datumsformat beachten!
   echo.
   echo.
   pause
   goto start
   goto :EOF    
   
:anpassen01
   set /a M=%M%+10
   if %J% EQU 00 (
      set J=99
      set /a H=%H%-1
      ) else (
           set /a J=%J%-1
        )
   goto :EOF


:anpassen02
   set /a M=%M%-2
   goto :EOF
   

:: ===================================================================================
:: ===================================================================================
:: ===================================================================================


:ENDE
echo.
echo.
pause